clear all
set more off
set scheme s2manual

use index
sjlog using logs/VAR, replace
tsset newdate
var SP500 FTSE100 Dax30 Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), lags(1)
predict res_SP500, residuals equation(SP500)
predict res_FTSE100, residuals equation(FTSE100)
predict res_Dax30, residuals equation(Dax30)
predict res_Nikkei225, residuals equation(Nikkei225)
sjlog close, replace

sjlog using logs/CorrSPFTSE, replace
summarize res_SP500 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar sdSP500_Precrisis = r(sd)
scalar N_precrisis = r(N)
summarize res_SP500 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar sdSP500_crisis = r(sd)
scalar N_crisis = r(N)
* Pearson correlation coefficient, precrisis
correlate res_SP500 res_FTSE100 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* Pearson correlation coefficient, crisis
correlate res_SP500 res_FTSE100 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis = r(rho)
* Forbes and Rigobon correlation coefficient, crisis
scalar delta = sdSP500_crisis^2/sdSP500_Precrisis^2-1
scalar corrFR_crisis = corr_crisis/sqrt(1+delta*(1-corr_crisis^2))
display "correlation precrisis = " corr_precrisis
display "correlation crisis = " corr_crisis
display "correlation crisis Forbes and Rigobon = " corrFR_crisis
sjlog close, replace

sjlog using logs/CorrSPFTSE1, replace
scalar var1 = (0.5*(1+delta)^2/(1+delta*(1-corr_crisis^2))^3*((2-corr_crisis^2)* (1-corr_crisis^2)^2/N_crisis+corr_crisis^2*(1-corr_crisis^2)^2/N_precrisis)) 
scalar var2 = 1/N_precrisis*(1-corr_precrisis^2)^2
scalar cov = 0.5*1/N_precrisis*corr_crisis*corr_precrisis*(1-corr_crisis^2)*(1-corr_precrisis^2)*(1+delta)/sqrt((1+ delta*(1-corr_crisis^2))^3)
scalar varTot = var1+var2-2*cov
display "t-test H0: correlation precrisis = FR correlation crisis  = " ((corrFR_crisis-corr_precrisis)/varTot^0.5)^2
sjlog close, replace

sjlog using logs/CorrForbes, replace
******************* DAX *******************************************************
* Pearson correlation coefficient, precrisis
correlate res_SP500 res_Dax30 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* Pearson correlation coefficient, crisis
correlate res_SP500 res_Dax30 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis = r(rho)
* Forbes and Rigobon correlation coefficient, crisis
scalar corrFR_crisis = corr_crisis/sqrt(1+delta*(1-corr_crisis^2))
display "correlation precrisis = " corr_precrisis
display "correlation crisis = " corr_crisis
display "correlation crisis Forbes and Rigobon= " corrFR_crisis
scalar var1 = (0.5*(1+delta)^2/(1+delta*(1-corr_crisis^2))^3*((2-corr_crisis^2)* (1-corr_crisis^2)^2/N_crisis+corr_crisis^2*(1-corr_crisis^2)^2/N_precrisis)) 
scalar var2 = 1/N_precrisis*(1-corr_precrisis^2)^2
scalar cov = 0.5*1/N_precrisis*corr_crisis*corr_precrisis*(1-corr_crisis^2)*(1-corr_precrisis^2)*(1+delta)/sqrt((1+ delta*(1-corr_crisis^2))^3)
scalar varTot = var1+var2-2*cov
display "t-test H0: correlation precrisis = FR correlation crisis  = " ((corrFR_crisis-corr_precrisis)/varTot^0.5)^2
******************* NIKKEI ****************************************************
* Pearson correlation coefficient, precrisis
correlate res_SP500 res_Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* Pearson correlation coefficient, crisis
correlate res_SP500 res_Nikkei225 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis = r(rho)
* Forbes and Rigobon correlation coefficient, crisis
scalar corrFR_crisis = corr_crisis/sqrt(1+delta*(1-corr_crisis^2))
display "correlation precrisis = " corr_precrisis
display "correlation crisis = " corr_crisis
display "correlation crisis Forbes and Rigobon= " corrFR_crisis
scalar var1 = (0.5*(1+delta)^2/(1+delta*(1-corr_crisis^2))^3*((2-corr_crisis^2)* (1-corr_crisis^2)^2/N_crisis+corr_crisis^2*(1-corr_crisis^2)^2/N_precrisis)) 
scalar var2 = 1/N_precrisis*(1-corr_precrisis^2)^2
scalar cov = 0.5*1/N_precrisis*corr_crisis*corr_precrisis*(1-corr_crisis^2)*(1-corr_precrisis^2)*(1+delta)/sqrt((1+ delta*(1-corr_crisis^2))^3)
scalar varTot = var1+var2-2*cov
display "t-test H0: correlation precrisis = FR correlation crisis  = " ((corrFR_crisis-corr_precrisis)/varTot^0.5)^2
sjlog close, replace
		
* CONTAGION BASED ON DCC		
sjlog using logs/CorrDCCContagion, replace
mgarch vcc Dax30 FTSE100 Nikkei225 SP500 if date>=mdy(01,01,2002) & date<=mdy(12,31,2009), arch(1) garch(1) nolog
predict corr*, correlation
sjlog close, replace

sjlog using logs/CorrDCCContagion1, replace
tsset date
tsline corr_SP500_FTSE100 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), tline(15sep2008) name(SPFTSE)
tsline corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), tline(15sep2008) name(SPDax)
tsline corr_SP500_Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), tline(15sep2008) name(SPNikkei)
graph combine SPFTSE SPDax SPNikkei
sjlog close, replace
graph export eps/DCC_Corr.eps, replace
graph export svg/DCC_Corr.svg, replace

*********** KOLOMOGOROV SMIRNOFF ****************************************
sjlog using logs/KS, replace
generate crisis=1 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
replace crisis=2 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
ksmirnov corr_SP500_FTSE100 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), by(crisis)
ksmirnov corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), by(crisis)
ksmirnov corr_SP500_Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), by(crisis)
sjlog close, replace

sjlog using logs/KSSPFTSE, replace
* SP500 FTSE
kdensity corr_SP500_FTSE100 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008), nograph generate(x kernel_pre_crisis)
kdensity corr_SP500_FTSE100 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009), nograph generate(kernel_crisis) at (x)
label var kernel_pre_crisis "S&P 500, FTSE 100 Precrisis"
label var kernel_crisis "S&P 500, FTSE 100 Crisis"
line kernel_pre_crisis kernel_crisis x, legend(col(1)) name(KSSPFTSE)
drop kernel_pre_crisis kernel_crisis x
kdensity corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008), nograph generate(x kernel_pre_crisis)
kdensity corr_SP500_Dax30 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009), nograph generate(kernel_crisis) at (x)
label var kernel_pre_crisis "S&P 500, Dax 30 Precrisis"
label var kernel_crisis "S&P 500, Dax 30 Crisis"
line kernel_pre_crisis kernel_crisis x, legend(col(1)) name(KSSPDAX)
* SP500 NIKKEI
drop kernel_pre_crisis kernel_crisis x
kdensity corr_SP500_Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008), nograph generate(x kernel_pre_crisis)
kdensity corr_SP500_Nikkei225 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009), nograph generate(kernel_crisis) at (x)
label var kernel_pre_crisis "S&P 500, Nikkei 225 Precrisis"
label var kernel_crisis "S&P 500, Nikkei 225 Crisis"
line kernel_pre_crisis kernel_crisis x, legend(col(1)) name(KSSPNikkei)
drop kernel_pre_crisis kernel_crisis x
graph combine KSSPFTSE KSSPDAX KSSPNikkei
sjlog close, replace
graph export eps/KSDensity.eps, replace
graph export svg/KSDensity.svg, replace

**************** MARKOV SWITCHING *******************************
tsline corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009)
graph export eps/CorrSPDax.eps, replace
graph export svg/CorrSPDax.svg, replace

sjlog using logs/MSDr, replace
tsset newdate
mswitch dr corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009)
sjlog close, replace

sjlog using logs/MSDRCorr, replace
estat transition
sjlog close, replace

sjlog using logs/MSDRDur, replace
estat duration
sjlog close, replace

sjlog using logs/SmoothP, replace
predict state1prob if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), pr smethod(filter)
generate state2prob = 1-state1prob
label var state1prob "State 1"
label var state2prob "State 2"
tsline corr_SP500_Dax30 state1prob state2prob if date >= mdy(01,01,2002) & date <= mdy(12,31,2009)
sjlog close, replace
graph export eps/FilteredProb.eps, replace
graph export svg/FilteredProb.svg, replace

sjlog using logs/MSDRD2, replace
mswitch dr corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), switch(L.corr_SP500_Dax30)
sjlog close, replace

sjlog using logs/MSDRD3, replace
mswitch dr corr_SP500_Dax30 L.corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009)
sjlog close, replace

sjlog using logs/MSAR, replace
mswitch ar corr_SP500_Dax30 if date >= mdy(01,01,2002) & date <= mdy(12,31,2009), ar(1)
sjlog close, replace

**************** COSKEWNESS ***********************************************
sjlog using logs/CoSkewSPFTSE, replace
* SP500
summarize SP500 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar sdSP500_precrisis = r(sd)
scalar meanSP500_precrisis = r(mean)
scalar N_precrisis = r(N)
summarize SP500 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar sdSP500_crisis = r(sd)
scalar meanSP500_crisis = r(mean)
scalar N_crisis = r(N)
* FTSE100
summarize FTSE100 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar sdFTSE100_precrisis=r(sd)
scalar meanFTSE100_precrisis=r(mean)
summarize FTSE100 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar sdFTSE100_crisis = r(sd)
scalar meanFTSE100_crisis = r(mean)
sjlog close, replace

sjlog using logs/CoSkewSPFTSE1, replace
* correlation precrisis
correlate SP500 FTSE100 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* crisis Forbes and Rigobon correlation
correlate SP500 FTSE100 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis=r(rho)
scalar corrFB_crisis = corr_crisis/sqrt(1+(sdSP500_crisis^2/sdSP500_precrisis^2-1)*(1-corr_crisis^2))
sjlog close, replace

sjlog using logs/CoSkewSPFTSE2, replace
generate psi_precrisis12 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^1*((FTSE100-meanFTSE100_precrisis)/sdFTSE100_precrisis)^2 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis12
scalar sum_psi_precrisis12 = r(sum)/r(N)
generate psi_precrisis21 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^2*((FTSE100-meanFTSE100_precrisis)/sdFTSE100_precrisis)^1 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis21
scalar sum_psi_precrisis21 = r(sum)/r(N)
generate psi_crisis12 = ((SP500-meanFTSE100_crisis)/sdSP500_crisis)^1*((FTSE100-meanFTSE100_crisis)/sdFTSE100_crisis)^2 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis12
scalar sum_psi_crisis12 = r(sum)/r(N)
generate psi_crisis21 = ((SP500-meanFTSE100_crisis)/sdSP500_crisis)^2*((FTSE100-meanFTSE100_crisis)/sdFTSE100_crisis)^1 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis21
scalar sum_psi_crisis21 = r(sum)/r(N)
scalar CS1 = ((sum_psi_crisis12-sum_psi_precrisis12)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
scalar CS2 = ((sum_psi_crisis21-sum_psi_precrisis21)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
display "CS1 = " CS1
display "CS2 = " CS2
display "Critical value = " invchi2(1,0.95)
drop psi_precrisis12 psi_precrisis21 psi_crisis12 psi_crisis21
sjlog close, replace

sjlog using logs/CoSkewDaxNikkei, replace
* DAX30
summarize Dax30 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar sdDax30_precrisis=r(sd)
scalar meanDax30_precrisis=r(mean)
summarize Dax30 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar sdDax30_crisis = r(sd)
scalar meanDax30_crisis = r(mean)
* correlation precrisis
correlate SP500 Dax30 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* crisis Forbes and Rigobon correlation
correlate SP500 Dax30 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis=r(rho)
scalar corrFB_crisis = corr_crisis/sqrt(1+(sdSP500_crisis^2/sdSP500_precrisis^2-1)*(1-corr_crisis^2))
generate psi_precrisis12 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^1*((Dax30-meanDax30_precrisis)/sdDax30_precrisis)^2 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis12
scalar sum_psi_precrisis12 = r(sum)/r(N)
generate psi_precrisis21 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^2*((Dax30-meanDax30_precrisis)/sdDax30_precrisis)^1 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis21
scalar sum_psi_precrisis21 = r(sum)/r(N)
generate psi_crisis12 = ((SP500-meanDax30_crisis)/sdSP500_crisis)^1*((Dax30-meanDax30_crisis)/sdDax30_crisis)^2 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis12
scalar sum_psi_crisis12 = r(sum)/r(N)
generate psi_crisis21 = ((SP500-meanDax30_crisis)/sdSP500_crisis)^2*((Dax30-meanDax30_crisis)/sdDax30_crisis)^1 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis21
scalar sum_psi_crisis21 = r(sum)/r(N)
scalar CS1 = ((sum_psi_crisis12-sum_psi_precrisis12)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
scalar CS2 = ((sum_psi_crisis21-sum_psi_precrisis21)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
display "CS1 = " CS1
display "CS2 = " CS2
display "Critical value = " invchi2(1,0.95)
drop psi_precrisis12 psi_precrisis21 psi_crisis12 psi_crisis21
* Nikkei225
summarize Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar sdNikkei225_precrisis=r(sd)
scalar meanNikkei225_precrisis=r(mean)
summarize Nikkei225 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar sdNikkei225_crisis = r(sd)
scalar meanNikkei225_crisis = r(mean)
* correlation precrisis
correlate SP500 Nikkei225 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
scalar corr_precrisis = r(rho)
* crisis Forbes and Rigobon correlation
correlate SP500 Nikkei225 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
scalar corr_crisis=r(rho)
scalar corrFB_crisis = corr_crisis/sqrt(1+(sdSP500_crisis^2/sdSP500_precrisis^2-1)*(1-corr_crisis^2))
generate psi_precrisis12 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^1*((Nikkei225-meanNikkei225_precrisis)/sdNikkei225_precrisis)^2 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis12
scalar sum_psi_precrisis12 = r(sum)/r(N)
generate psi_precrisis21 = ((SP500-meanSP500_precrisis)/sdSP500_precrisis)^2*((Nikkei225-meanNikkei225_precrisis)/sdNikkei225_precrisis)^1 if date >= mdy(01,01,2002) & date <= mdy(09,14,2008)
summarize psi_precrisis21
scalar sum_psi_precrisis21 = r(sum)/r(N)
generate psi_crisis12 = ((SP500-meanNikkei225_crisis)/sdSP500_crisis)^1*((Nikkei225-meanNikkei225_crisis)/sdNikkei225_crisis)^2 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis12
scalar sum_psi_crisis12 = r(sum)/r(N)
generate psi_crisis21 = ((SP500-meanNikkei225_crisis)/sdSP500_crisis)^2*((Nikkei225-meanNikkei225_crisis)/sdNikkei225_crisis)^1 if date >= mdy(09,15,2008) & date <= mdy(12,31,2009)
summarize psi_crisis21
scalar sum_psi_crisis21 = r(sum)/r(N)
scalar CS1 = ((sum_psi_crisis12-sum_psi_precrisis12)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
scalar CS2 = ((sum_psi_crisis21-sum_psi_precrisis21)/sqrt((4*corrFB_crisis^2+2)/N_crisis+(4*corr_precrisis^2+2)/N_precrisis))^2
display "CS1 = " CS1
display "CS2 = " CS2
display "Critical value = " invchi2(1,0.95)
sjlog close, replace
